//  Streetdeck has anti-debugging code builtin to the startup routines; however
//  It does not have the same anti-debug checks once running
//  To use OllyDbg, start Streetdeck.  Then in Olly, attach the process
// 
//  Key Breakpoints
// 	Start of Read Serial Routine				0056EFB9
// 	To read the Serial you input				0056EFF2
// 	MD5 Calculation Subroutine with 6xArguments		00AD0226
// 		Arg5 is the License Type (optionstring below)
// 	The input is MD5'd Three times
// 		First Hash (Plain Text combinedcode below)	00ACFF5A
// 		Second Hash (Hash of First Hash - Post-XOR)	00ACFFE6
// 		Third Hash (Hash of Second Hash - Post-XOR)	00AD006A
// 	Read a Valid Code					005E9985

#include "stdafx.h"
 
using namespace std;
 
int _tmain(int argc, char *argv[])
{
	unsigned char retdigest[16];
	unsigned int intdigest[4];
	unsigned int intxor[4];
	unsigned int intdigest2[4]; // need to keep the first one for xor with 3rd
	unsigned int intdigest3[4]; // need to keep the second for final calc
	unsigned char retdigest2[16 + 12]; // retdigest + optionstring 1-8
	
	string machinecode = "AAAXYAXX";  // VM Test Machine Code
	string checkcode = "ZYEBYADY"; // VM Test Check Code
	string selectedoption_str;
	string optionstring;
	int selectedoption;
	string combinedcode;
	string finalcode;
											// Valid Codes for VM Test
	string optionstring1 = "0E9B69EB-637"; // Streetdeck Version 1 			(LTHSOQIWXRKWVNCHFAGSL)
	string optionstring2 = "DIOL:SDK-5A4"; // North American Navigation Ultimate	(BGFRRWOUPGXXWEQSIWNIA)
	string optionstring3 = "6F531732-54C"; // Base Application			(CTLTBBPKQXWZUYYAURMIG)
	string optionstring4 = "3CE6DF09-CBE"; // European Navigation Ultimate		(PVTUGGMKTVRWXBUPPQLHA)
	string optionstring5 = "92F18915-89F"; // Extended North American POIs		(WSEQDUQMUTQSXWCOOWGLI)
	string optionstring6 = "5945B8DA-918"; // Extended European POIs		(VIHJYSTNWIBTUIPQPURHH)
	string optionstring7 = "CCE47B89-5AB"; // North American Navigation (6 Month)	(EURQZYOATLIGIUSHVJQPI)
	string optionstring8 = "93EAA4E8-7F7"; // North American Navigation		(RWPTHUIXDUREZPANRTCEC)
	
	cout << "*******************************************" << endl;
	cout << "\tStreetDeck Version 2 KeyGen" << endl;
	cout << "\t\tBy: Jagaer" << endl;
	cout << "*******************************************" << endl;
	
	do
	{
		cout << "Enter your Machine Code: ";
		cin >> machinecode;
		if (machinecode.length() != 8)
			cout << "\nMachine Code must be 8 digits" << endl;
	} while (machinecode.length() != 8);
	transform(machinecode.begin(), machinecode.end(), machinecode.begin(), ::toupper);
	
	do
	{
		cout << "  Enter your Check Code: ";
		cin >> checkcode;
		if (checkcode.length() != 8)
			cout << "\nCheck Code must be 8 digits" << endl;
	} while (checkcode.length() != 8);
	transform(checkcode.begin(), checkcode.end(), checkcode.begin(), ::toupper);
	
	cout << "\nWhich code should be generated (Select 1-8)" << endl;
	cout << "\t1) Streetdeck Version 1" << endl;
	cout << "\t2) North American Navigation Ultimate" << endl;
	cout << "\t3) Base Application" << endl;
	cout << "\t4) European Navigation Ultimate" << endl;
	cout << "\t5) Extended North American POIs" << endl;
	cout << "\t6) Extended European POIs" << endl;
	cout << "\t7) North American Navigation (6 Month)" << endl;
	cout << "\t8) North American Navigation" << endl;
	
	selectedoption = 0;
	do
	{
		cout << "Selection: ";
		cin >> selectedoption_str;
		selectedoption = atoi(selectedoption_str.c_str());
		if (selectedoption < 1 || selectedoption > 8)
			cout << "\nEnter a valid option" << endl;
	} while (selectedoption < 1 || selectedoption > 8);
	
	switch (selectedoption)
	{
		case 1:
			cout << "Streetdeck Version 1";
			optionstring = optionstring1;
			break;
		case 2:
			cout << "North American Navigation Ultimate";
			optionstring = optionstring2;
			break;
		case 3:
			cout << "Base Application";
			optionstring = optionstring3;
			break;
		case 4:
			cout << "European Navigation Ultimate";
			optionstring = optionstring4;
			break;
		case 5:
			cout << "Extended North American POIs (Can only be added after a Navigation License has been applied)";
			optionstring = optionstring5;
			break;
		case 6:
			cout << "Extended European POIs (Can only be added after a Navigation License has been applied)";
			optionstring = optionstring6;
			break;
		case 7:
			cout << "North American Navigation (6 Month)";
			optionstring = optionstring7;
			break;
		case 8:
			cout << "North American Navigation";
			optionstring = optionstring8;
			break;
		default:
			cout << "Much bad things";
			break;
	}
	cout << " Selected" << endl << endl;
	
	combinedcode = "";
	for (int i = 0; i < 8; i++)
	{
		combinedcode += checkcode[i];
		combinedcode += machinecode[i];
		combinedcode += (0x43 + i);
	}
	cout << " Machine Code: " << machinecode << endl;
	cout << "   Check Code: " << checkcode << endl;
	cout << "Combined Code: " << combinedcode << endl;
	
	string instring = combinedcode.substr(0, 16) + optionstring;
	cout << "       Option: " << optionstring << " With Combined Code " << instring << endl;
	
//////////////////////////////////////////////////////////////////////////////
//	First MD5 round, on the 28 Text Characters "instring" generated from the first 16 characters of the "combinedcode" and "optionstring"

	MD5 *md5obj1 = new MD5();
	md5obj1->update(instring.c_str(), instring.length());
	md5obj1->finalize();
	md5obj1->getdigest(retdigest);
	
	for (int i = 0; i < 4; i++)
	{
		intdigest[i] = (retdigest[i * 4] << 24) | (retdigest[i * 4 + 1] << 16) | (retdigest[i * 4 + 2] << 8) | (retdigest[i * 4 + 3]);
	}

	for (int i = 0; i < 2; i++)
	{
		intxor[i] = (combinedcode[i * 4 + 16] << 24) | (combinedcode[i * 4 + 17] << 16) | (combinedcode[i * 4 + 18] << 8) | (combinedcode[i * 4 + 19]);
	}
	
//	XOR the first two digest states with the final 8 Characters of the "combinedcode"
	intdigest[0] = intdigest[0] ^ intxor[0];
	intdigest[1] = intdigest[1] ^ intxor[1];
	
	for (int i = 0; i < 2; i++)
	{
		retdigest[i*4+3] = intdigest[i] & 0xff;
		retdigest[i*4+2] = (intdigest[i] >> 8) & 0xff;
		retdigest[i*4+1] = (intdigest[i] >> 16) & 0xff;
		retdigest[i*4] = (intdigest[i] >> 24) & 0xff;
	}

//	End First round
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	Second MD5 round, on the First Round - Post-XOR'd digest

	MD5 *md5obj2 = new MD5();
	md5obj2->update(retdigest, 16);
	md5obj2->finalize();
	md5obj2->getdigest(retdigest);
	
	for (int i = 0; i < 4; i++)
	{
		intdigest2[i] = (retdigest[i * 4] << 24) | (retdigest[i * 4 + 1] << 16) | (retdigest[i * 4 + 2] << 8) | (retdigest[i * 4 + 3]);
	}
	
//	XOR all four digest states with the first 16 Characters of the "combinedcode"
	for (int i = 0; i < 4; i++)
	{
		intxor[i] = (combinedcode[i * 4] << 24) | (combinedcode[i * 4 + 1] << 16) | (combinedcode[i * 4 + 2] << 8) | (combinedcode[i * 4 + 3]);
		intdigest2[i] = intdigest2[i] ^ intxor[i];
	}
	
	for (int i = 0; i < 4; i++)
	{
		retdigest[i*4+3] = intdigest2[i] & 0xff;
		retdigest[i*4+2] = (intdigest2[i] >> 8) & 0xff;
		retdigest[i*4+1] = (intdigest2[i] >> 16) & 0xff;
		retdigest[i*4] = (intdigest2[i] >> 24) & 0xff;
	}
//	End Second round
//////////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////////
//	Third MD5 round, on the Second Round - Post-XOR'd digest with the "optionstring" added to the end

//	Save the digest from the Second Round for the end.
	memcpy(retdigest2, retdigest, 16);
	
	for (int i = 0; i < 12; i++)
	{
		retdigest2[16 + i] = optionstring[i];
	}
	
	MD5 *md5obj3 = new MD5();
	md5obj3->update(retdigest2, (16 + 12));
	md5obj3->finalize();
	md5obj3->getdigest(retdigest);
	
	for (int i = 0; i < 4; i++)
	{
		intdigest3[i] = (retdigest[i * 4] << 24) | (retdigest[i * 4 + 1] << 16) | (retdigest[i * 4 + 2] << 8) | (retdigest[i * 4 + 3]);
	}

//	XOR all four digest states with the post-XOR'd digests from the first round
	for (int i = 0; i < 4; i++)
	{
		intdigest3[i] = intdigest3[i] ^ intdigest[i];
	}
//	End Second round
//////////////////////////////////////////////////////////////////////////////
	
//////////////////////////////////////////////////////////////////////////////
//	Compute the Final Registration Code by:
//	Converting each of the bytes in the third digest and the first five bytes in the second digest into ASCII

	finalcode = "";
	string temp;
	int i = 0;
	int j = 0;
	for (j = 0; j < 4; j++)
	{
		finalcode += (((intdigest3[j] >> 24) & 0xff) % 26) + 0x41;
		finalcode += (((intdigest3[j] >> 16) & 0xff) % 26) + 0x41;
		finalcode += (((intdigest3[j] >> 8) & 0xff) % 26) + 0x41;
		finalcode += ((intdigest3[j] & 0xff) % 26) + 0x41;
	}
	
	finalcode += (((intdigest2[0] >> 24) & 0xff) % 26) + 0x41;
	finalcode += (((intdigest2[0] >> 16) & 0xff) % 26) + 0x41;
	finalcode += (((intdigest2[0] >> 8) & 0xff) % 26) + 0x41;
	finalcode += ((intdigest2[0] & 0xff) % 26) + 0x41;
	finalcode += (((intdigest2[1] >> 24) & 0xff) % 26) + 0x41;
	
	finalcode = finalcode.insert(7, " ");
	finalcode = finalcode.insert(15, " ");
	
	cout << "\n   Final Code: " << finalcode << endl << endl;

	delete md5obj1;
	delete md5obj2;
	delete md5obj3;

	system("PAUSE");
	return 0;
}